/*
 * PunchcardDisplayDialog.java
 *
 * Created on October 16, 2008, 4:37 PM
 */

package jdbernard.timestamper;

import java.awt.Point;
import java.awt.Rectangle;
import java.awt.Toolkit;
import java.awt.event.MouseEvent;
import java.awt.event.MouseMotionListener;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import org.jdesktop.application.Action;

/**
 *
 * @author  jbernard
 */
public class PunchcardDisplayDialog extends JDialog
implements MouseMotionListener, ChangeListener {

    /* Layout of class code:
     * Constructors
     * Generated GUI init code
     * Generated class variables
     * Additional class variables
     * Action methods
     * Listener methods
     * Additional methods
     */

    /** Creates new form PunchcardDisplayDialog */
    public PunchcardDisplayDialog(JFrame parent, boolean modal,
            Calendar day) {
        super(parent, modal);
        this.day = day;
        initComponents();

        dayDisplay.setDay(day.getTime());
        dateLabel.setText(dateFormatter.format(day.getTime()));

        dayDisplay.addChangeListener(this);
        addChangeListener(dayDisplay);

        markTextField.setFont(dayDisplay.getMarkFont());
        notesTextArea.setFont(dayDisplay.getNotesFont());
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        mainPanel = new javax.swing.JPanel();
        dayDisplay = new jdbernard.timestamper.TimelineDayDisplay();
        detailPanel = new javax.swing.JPanel();
        textPane = new javax.swing.JPanel();
        markTextField = new javax.swing.JTextField();
        notesScrollPane = new javax.swing.JScrollPane();
        notesTextArea = new javax.swing.JTextArea();
        timestampDateChooser = new com.toedter.calendar.JDateChooser();
        buttonPanel = new javax.swing.JPanel();
        datePanel = new javax.swing.JPanel();
        dateLabel = new javax.swing.JLabel();
        prevWeekButton = new javax.swing.JButton();
        prevDayButton = new javax.swing.JButton();
        currentDayButton = new javax.swing.JButton();
        nextDayButton = new javax.swing.JButton();
        nextWeekButton = new javax.swing.JButton();
        newMarkerButton = new javax.swing.JButton();
        deleteMarkerButton = new javax.swing.JButton();
        saveMarkerChanges = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setName("Form"); // NOI18N
        setUndecorated(true);

        mainPanel.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0), 2));
        mainPanel.setName("mainPanel"); // NOI18N
        mainPanel.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                mainPanelMousePressed(evt);
            }
        });
        mainPanel.addMouseMotionListener(this);

        dayDisplay.setName("dayDisplay"); // NOI18N
        dayDisplay.setPreferredSize(new java.awt.Dimension(100, 100));

        javax.swing.GroupLayout dayDisplayLayout = new javax.swing.GroupLayout(dayDisplay);
        dayDisplay.setLayout(dayDisplayLayout);
        dayDisplayLayout.setHorizontalGroup(
            dayDisplayLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 405, Short.MAX_VALUE)
        );
        dayDisplayLayout.setVerticalGroup(
            dayDisplayLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 339, Short.MAX_VALUE)
        );

        detailPanel.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        detailPanel.setName("detailPanel"); // NOI18N

        textPane.setName("textPane"); // NOI18N

        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(jdbernard.timestamper.TimeStamperApp.class).getContext().getResourceMap(PunchcardDisplayDialog.class);
        markTextField.setText(resourceMap.getString("markTextField.text")); // NOI18N
        markTextField.setName("markTextField"); // NOI18N

        notesScrollPane.setName("notesScrollPane"); // NOI18N

        notesTextArea.setColumns(20);
        notesTextArea.setLineWrap(true);
        notesTextArea.setRows(5);
        notesTextArea.setWrapStyleWord(true);
        notesTextArea.setName("notesTextArea"); // NOI18N
        notesScrollPane.setViewportView(notesTextArea);

        timestampDateChooser.setDateFormatString(resourceMap.getString("timestampDateChooser.dateFormatString")); // NOI18N
        timestampDateChooser.setName("timestampDateChooser"); // NOI18N

        javax.swing.GroupLayout textPaneLayout = new javax.swing.GroupLayout(textPane);
        textPane.setLayout(textPaneLayout);
        textPaneLayout.setHorizontalGroup(
            textPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, textPaneLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(textPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(notesScrollPane, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 238, Short.MAX_VALUE)
                    .addComponent(timestampDateChooser, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 238, Short.MAX_VALUE)
                    .addComponent(markTextField, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 238, Short.MAX_VALUE))
                .addContainerGap())
        );
        textPaneLayout.setVerticalGroup(
            textPaneLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(textPaneLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(timestampDateChooser, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(markTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(notesScrollPane, javax.swing.GroupLayout.DEFAULT_SIZE, 36, Short.MAX_VALUE)
                .addContainerGap())
        );

        buttonPanel.setName("buttonPanel"); // NOI18N
        buttonPanel.setLayout(new java.awt.GridBagLayout());

        datePanel.setName("datePanel"); // NOI18N
        datePanel.setLayout(new java.awt.GridBagLayout());

        dateLabel.setBackground(resourceMap.getColor("dateLabel.background")); // NOI18N
        dateLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        dateLabel.setText(resourceMap.getString("dateLabel.text")); // NOI18N
        dateLabel.setName("dateLabel"); // NOI18N
        dateLabel.setOpaque(true);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        datePanel.add(dateLabel, gridBagConstraints);

        javax.swing.ActionMap actionMap = org.jdesktop.application.Application.getInstance(jdbernard.timestamper.TimeStamperApp.class).getContext().getActionMap(PunchcardDisplayDialog.class, this);
        prevWeekButton.setAction(actionMap.get("previousWeek")); // NOI18N
        prevWeekButton.setHideActionText(true);
        prevWeekButton.setMargin(new java.awt.Insets(0, 2, 0, 2));
        prevWeekButton.setName("prevWeekButton"); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        datePanel.add(prevWeekButton, gridBagConstraints);

        prevDayButton.setAction(actionMap.get("previousDay")); // NOI18N
        prevDayButton.setHideActionText(true);
        prevDayButton.setMargin(new java.awt.Insets(0, 2, 0, 2));
        prevDayButton.setName("prevDayButton"); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        datePanel.add(prevDayButton, gridBagConstraints);

        currentDayButton.setAction(actionMap.get("currentDay")); // NOI18N
        currentDayButton.setMargin(new java.awt.Insets(0, 2, 0, 2));
        currentDayButton.setName("currentDayButton"); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        datePanel.add(currentDayButton, gridBagConstraints);

        nextDayButton.setAction(actionMap.get("nextDay")); // NOI18N
        nextDayButton.setHideActionText(true);
        nextDayButton.setMargin(new java.awt.Insets(0, 2, 0, 2));
        nextDayButton.setName("nextDayButton"); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 1;
        datePanel.add(nextDayButton, gridBagConstraints);

        nextWeekButton.setAction(actionMap.get("nextWeek")); // NOI18N
        nextWeekButton.setHideActionText(true);
        nextWeekButton.setMargin(new java.awt.Insets(0, 2, 0, 2));
        nextWeekButton.setName("nextWeekButton"); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 1;
        datePanel.add(nextWeekButton, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        buttonPanel.add(datePanel, gridBagConstraints);

        newMarkerButton.setAction(actionMap.get("newMarker")); // NOI18N
        newMarkerButton.setName("newMarkerButton"); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        buttonPanel.add(newMarkerButton, gridBagConstraints);

        deleteMarkerButton.setAction(actionMap.get("deleteMarker")); // NOI18N
        deleteMarkerButton.setName("deleteMarkerButton"); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        buttonPanel.add(deleteMarkerButton, gridBagConstraints);

        saveMarkerChanges.setAction(actionMap.get("saveMarkerChanges")); // NOI18N
        saveMarkerChanges.setName("saveMarkerChanges"); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        buttonPanel.add(saveMarkerChanges, gridBagConstraints);

        javax.swing.GroupLayout detailPanelLayout = new javax.swing.GroupLayout(detailPanel);
        detailPanel.setLayout(detailPanelLayout);
        detailPanelLayout.setHorizontalGroup(
            detailPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, detailPanelLayout.createSequentialGroup()
                .addComponent(textPane, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(buttonPanel, javax.swing.GroupLayout.PREFERRED_SIZE, 139, javax.swing.GroupLayout.PREFERRED_SIZE))
        );
        detailPanelLayout.setVerticalGroup(
            detailPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(buttonPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(textPane, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );

        javax.swing.GroupLayout mainPanelLayout = new javax.swing.GroupLayout(mainPanel);
        mainPanel.setLayout(mainPanelLayout);
        mainPanelLayout.setHorizontalGroup(
            mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, mainPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(dayDisplay, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 405, Short.MAX_VALUE)
                    .addComponent(detailPanel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        mainPanelLayout.setVerticalGroup(
            mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, mainPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(dayDisplay, javax.swing.GroupLayout.DEFAULT_SIZE, 339, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(detailPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(mainPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(mainPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

private void mainPanelMousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_mainPanelMousePressed
    mousePressRelativeToWindow = evt.getPoint();
}//GEN-LAST:event_mainPanelMousePressed


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel buttonPanel;
    private javax.swing.JButton currentDayButton;
    private javax.swing.JLabel dateLabel;
    private javax.swing.JPanel datePanel;
    private jdbernard.timestamper.TimelineDayDisplay dayDisplay;
    private javax.swing.JButton deleteMarkerButton;
    private javax.swing.JPanel detailPanel;
    private javax.swing.JPanel mainPanel;
    private javax.swing.JTextField markTextField;
    private javax.swing.JButton newMarkerButton;
    private javax.swing.JButton nextDayButton;
    private javax.swing.JButton nextWeekButton;
    private javax.swing.JScrollPane notesScrollPane;
    private javax.swing.JTextArea notesTextArea;
    private javax.swing.JButton prevDayButton;
    private javax.swing.JButton prevWeekButton;
    private javax.swing.JButton saveMarkerChanges;
    private javax.swing.JPanel textPane;
    private com.toedter.calendar.JDateChooser timestampDateChooser;
    // End of variables declaration//GEN-END:variables

    private Calendar day;
    private SimpleDateFormat dateFormatter = new SimpleDateFormat("EEE MMM dd");
    private Point mousePressRelativeToWindow;
    private ArrayList<ChangeListener> changeListeners =
            new ArrayList<ChangeListener>();

    @Action
    public void previousWeek() {
        day.add(Calendar.WEEK_OF_YEAR, -1);
        dayDisplay.setDay(day.getTime());
        dateLabel.setText(dateFormatter.format(day.getTime()));
        repaint();
    }

    @Action
    public void previousDay() {
        day.add(Calendar.DAY_OF_YEAR, -1);
        dayDisplay.setDay(day.getTime());
        dateLabel.setText(dateFormatter.format(day.getTime()));
        repaint();
    }

    @Action
    public void currentDay() {
        day = Calendar.getInstance();
        dayDisplay.setDay(day.getTime());
        dateLabel.setText(dateFormatter.format(day.getTime()));
        repaint();
    }

    @Action
    public void nextDay() {
        day.add(Calendar.DAY_OF_YEAR, 1);
        dayDisplay.setDay(day.getTime());
        dateLabel.setText(dateFormatter.format(day.getTime()));
        repaint();
    }

    @Action
    public void nextWeek() {
        day.add(Calendar.WEEK_OF_YEAR, 1);
        dayDisplay.setDay(day.getTime());
        dateLabel.setText(dateFormatter.format(day.getTime()));
        repaint();
    }

    @Action
    public void newMarker() {
        dayDisplay.addMarker(timestampDateChooser.getDate(),
            markTextField.getText(), notesTextArea.getText());
        fireChangeEvent();
        repaint();
    }

    @Action
    public void deleteMarker() {
        dayDisplay.deleteSelectedMarker();
        fireChangeEvent();
        repaint();
    }

    @Action
    public void saveMarkerChanges() {
        deleteMarker();
        newMarker();
    }

    public void mouseDragged(MouseEvent e) {
        setLocation(TimeStamperView.calculateWindowMovement(
                e.getLocationOnScreen(), mousePressRelativeToWindow,
                getBounds(),
                new Rectangle(Toolkit.getDefaultToolkit().getScreenSize())));
    }

    public void mouseMoved(MouseEvent e) {
    }

    private void fireChangeEvent() {
        ChangeEvent ce = new ChangeEvent(this);

        for (ChangeListener cl : changeListeners)
            cl.stateChanged(ce);
    }

    public void stateChanged(ChangeEvent e) {
        if (e.getSource() == dayDisplay) {
            Timeline.TimelineMarker marker = dayDisplay.getSelectedTimelineMarker();

            if (marker == null) {
                timestampDateChooser.setDate(null);
                markTextField.setText("");
                notesTextArea.setText("");
            } else {
                timestampDateChooser.setDate(marker.getTimestamp());
                markTextField.setText(marker.getMark());
                notesTextArea.setText(marker.getNotes());
            }
        } else {
            for (ChangeListener cl : changeListeners)
                if (cl != e.getSource()) cl.stateChanged(e);
        }

    }

    public void addChangeListener(ChangeListener cl) {
        changeListeners.add(cl);
    }

    public boolean removeChangeListener(ChangeListener cl) {
        return changeListeners.remove(cl);
    }

    /**
    * @param args the command line arguments
    *
    public static void main(String args[]) throws Exception {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                Timeline timeline = null;
                Calendar day = Calendar.getInstance();
                try { timeline = Timeline.readFromFile("test-timeline.txt"); }
                catch (Exception e) {
                    System.err.println("Could not open timeline text:");
                    e.printStackTrace(System.err);
                    timeline = new Timeline();
                    try { new File("PLACE_HERE").createNewFile(); }
                    catch (Exception e1) {}
                }
                PunchcardDisplayDialog dialog = new PunchcardDisplayDialog(new javax.swing.JFrame(), true, timeline, day);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }*/

}
